% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}
\usepackage{../../../../grammar}
\usepackage{graphicx}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Four.IV\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
Let $\lang_0=\set{\str{a}^n\str{b}^{2m}\suchthat n,m\geq 1}$.
Let $\lang_1=\set{\str{a}^n\str{b}^{3m}\suchthat n,m\geq 1}$.
\begin{parts}
\part List five members of $\lang_0$, and also list five members of $\lang_1$.
Also list five nonmembers of each.
\begin{solution}
Members of $\lang_0$: \str{abb}, \str{aabb}, \str{aabbbb}, $\str{a}^7\str{b}^6$.
Nonmembers: \emptystring, \str{ba}, \str{a}, \str{b}, \str{aaaa}.

Members of $\lang_1$: $\str{a}\str{b}^3=\str{abbb}$, 
$\str{a}\str{b}^6$, 
\str{aabbb}, 
$\str{aaa}\str{b}^6$,
$\str{a}\str{b}^9$.
Nonmembers: \emptystring, \str{ba}, \str{a}, \str{b}, \str{abb}.
\end{solution}

\part Show that $\lang_0$ is a regular language by 
describing it with a regular expression.
Then give a Finite State machine that accepts~$\lang_0$
\begin{solution}
A regular expression is \re{aa*bb(bb)*}.
Here is a nondeterministic machine.
\begin{center}
  \includegraphics{asy/automata009.pdf}
\end{center}
\end{solution}

\part Do the same for $\lang_1$.
\begin{solution}
A regular expression is \re{aa*bbb(bbb)*}.
Here is a Finite State machine.
\begin{center}
  \includegraphics{asy/automata010.pdf}
\end{center}
\end{solution}

\part List five members of of the concatenation of the languges,
$\lang_0\concat\lang_1$.
\begin{solution}
Five members of $\lang_0\concat\lang_1$:
\str{abbabbb}, $\str{aa}\str{b}^2\str{aa}\str{b}^3$,
$\str{a}\str{b}^2\str{a}^5\str{b}^3$,
$\str{aaa}\str{b}^2\str{aa}\str{b}^9$,
and $\str{a}\str{b}^6\str{a}\str{b}^6$.
Non-members: \emptystring, \str{b}, \str{a}
$\str{a}\str{b}^2\str{a}$,
and $\str{a}\str{b}^2\str{a}\str{b}^3a$.
\end{solution}

\part Give a regular expression that describes the language
$\lang_0\concat\lang_1$.
\begin{solution}
\re{aa*bb(bb)*aa*bbb(bbb)*}
\end{solution}

\part List five members of the Kleene closure $\kleenestar{\lang_0}\!$.
\begin{solution}
\str{abb}, \emptystring, \str{abbabb}, \str{aabbbbabb}, \str{abbbbaaabb}
\end{solution}

\part Give a regular expression to describe the language
 $\kleenestar{\lang_0}$.
 \begin{solution}
 \re{(aa*bb(bb)*)*}
 \end{solution}
\end{parts}


\question
Consider these two machines.
\begin{center}
\begin{tabular}{r|cc}
  \multicolumn{1}{c}{$\mathcal{M}_0$}
    &\multicolumn{1}{c}{\str{a}}  &\multicolumn{1}{c}{\str{b}}
  \\ \cline{2-3}
  $+q_0$  &$q_0$  &$q_1$  \\ 
  $+q_1$  &$q_2$  &$q_1$  \\ 
  $q_2$   &$q_2$  &$q_2$   
\end{tabular}
\qquad
\begin{tabular}{r|cc}
  \multicolumn{1}{c}{$\mathcal{M}_1$}
    &\multicolumn{1}{c}{\str{a}}  &\multicolumn{1}{c}{\str{b}}
  \\ \cline{2-3}
  $+r_0$  &$r_1$  &$r_1$  \\ 
  $r_1$   &$r_0$  &$r_0$  
\end{tabular}
\end{center}
\begin{parts}
\part List the members of the cross product of the sets of states,
$Q\times R$.
\begin{solution}
$Q\times R=\set{(q_0,r_0),\,
(q_0,r_1),\,
(q_1,r_0),\,
(q_1,r_1),\,
(q_2,r_0),\,
(q_2,r_1)
}$
\end{solution}

\part Define a machine~$\mathcal{M}$ 
  whose states are the members of $Q\times R$,
  and whose transition function is given by the transitions
  of $\mathcal{M}_0$ and~$\mathcal{M}_1$ in the separate coordinates.
  \begin{equation*}
    \Delta(\,(q_i,r_j)\,)=(\Delta_0(q_i),\,\Delta_1(r_j))
  \end{equation*}
  Produce the table.
  Ignore the question of which states are final.
\begin{solution}
\begin{center}
\begin{tabular}{r|*{2}{c}}
  \multicolumn{1}{r}{$\Delta$} 
    &\multicolumn{1}{c}{\str{a}} &\multicolumn{1}{c}{\str{b}}  
  \\ \cline{2-3}
  $(q_0,r_0)$ &$(q_0,r_1)$ &$(q_1,r_1)$  \\
  $(q_0,r_1)$ &$(q_0,r_0)$ &$(q_1,r_0)$  \\
  $(q_1,r_0)$ &$(q_2,r_1)$ &$(q_1,r_1)$  \\
  $(q_1,r_1)$ &$(q_2,r_0)$ &$(q_1,r_0)$  \\
  $(q_2,r_0)$ &$(q_2,r_1)$ &$(q_2,r_1)$  \\
  $(q_2,r_1)$ &$(q_2,r_0)$ &$(q_2,r_0)$  \\
\end{tabular}
\end{center}
\end{solution}

\part Copy that machine, making a state $(q_i,r_j)$ final if either
of $q_i$ or $r_j$ is final.
What language does it accept?
\begin{solution}
This machine accepts $\lang_0\cup\lang_1$.
\begin{center}
\begin{tabular}{r|*{2}{c}}
  \multicolumn{1}{r}{$\Delta_0$} 
    &\multicolumn{1}{c}{\str{a}} &\multicolumn{1}{c}{\str{b}}  
  \\ \cline{2-3}
  \acceptingstate{} $(q_0,r_0)$ &$(q_0,r_1)$ &$(q_1,r_1)$  \\
  \acceptingstate{} $(q_0,r_1)$ &$(q_0,r_0)$ &$(q_1,r_0)$  \\
  \acceptingstate{} $(q_1,r_0)$ &$(q_2,r_1)$ &$(q_1,r_1)$  \\
  \acceptingstate{} $(q_1,r_1)$ &$(q_2,r_0)$ &$(q_1,r_0)$  \\
  \acceptingstate{} $(q_2,r_0)$ &$(q_2,r_1)$ &$(q_2,r_1)$  \\
  $(q_2,r_1)$ &$(q_2,r_0)$ &$(q_2,r_0)$  \\
\end{tabular}
\end{center}
\end{solution}

\part Copy that machine, making a state $(q_i,r_j)$ final if both
of $q_i$ and $r_j$ are final.
What language does it accept?
\begin{solution}
This machine accepts $\lang_0\cap\lang_1$.
\begin{center}
\begin{tabular}{r|*{2}{c}}
  \multicolumn{1}{r}{$\Delta_1$} 
    &\multicolumn{1}{c}{\str{a}} &\multicolumn{1}{c}{\str{b}}  
  \\ \cline{2-3}
  \acceptingstate{} $(q_0,r_0)$ &$(q_0,r_1)$ &$(q_1,r_1)$  \\
  $(q_0,r_1)$ &$(q_0,r_0)$ &$(q_1,r_0)$  \\
  \acceptingstate{} $(q_1,r_0)$ &$(q_2,r_1)$ &$(q_1,r_1)$  \\
  $(q_1,r_1)$ &$(q_2,r_0)$ &$(q_1,r_0)$  \\
  $(q_2,r_0)$ &$(q_2,r_1)$ &$(q_2,r_1)$  \\
  $(q_2,r_1)$ &$(q_2,r_0)$ &$(q_2,r_0)$  \\
\end{tabular}
\end{center}
\end{solution}

\part Now, make a state final if $q_i$ is final but $r_j$ is not.
What language does it accept?
\begin{solution}
This machine accepts $\lang_0-\lang_1$ (the set difference).
\begin{center}
\begin{tabular}{r|*{2}{c}}
  \multicolumn{1}{r}{$\Delta_2$} 
    &\multicolumn{1}{c}{\str{a}} &\multicolumn{1}{c}{\str{b}}  
  \\ \cline{2-3}
  $(q_0,r_0)$ &$(q_0,r_1)$ &$(q_1,r_1)$  \\
  \acceptingstate{} $(q_0,r_1)$ &$(q_0,r_0)$ &$(q_1,r_0)$  \\
  $(q_1,r_0)$ &$(q_2,r_1)$ &$(q_1,r_1)$  \\
  \acceptingstate{} $(q_1,r_1)$ &$(q_2,r_0)$ &$(q_1,r_0)$  \\
  $(q_2,r_0)$ &$(q_2,r_1)$ &$(q_2,r_1)$  \\
  $(q_2,r_1)$ &$(q_2,r_0)$ &$(q_2,r_0)$  \\
\end{tabular}
\end{center}
\end{solution}

\end{parts}



\end{questions}
\end{document}
